#include <stdio.h>
#include <math.h>
#include <stdlib.h>

void n_cls(void);
void n_plot(int,int,int);
void n_col(int,int,int,int);

typedef struct Wang {
  float harm;  /* which harmonic # */
  float start;  /* how many bytes it starts */
  float end;    /* where it ends */
  float length; /* its length */
  float stamp;  /* start amplitude */
  float enamp;  /* end amplitude */
  float ampmag; /* amplitude magnitude */
  float stpha;  /* starting phase */
  float enpha;  /* ending phase */
  float phamag; /* phase magnitude */
} wang;

unsigned char *va;

void main(int argc,char *argv[]){
  FILE *fi_in, *fi_out;
  wang sound[16];
  int done=0;
  int sn=0;
  int length=-1;
  int s,hi=0,c;  /* shic! */
  float comp,mul;
  int x,e_x,col,e_col,yval;
  float pos,fl,ph,phmag,am,ammag,amval,freq;

  /* read dat shit in */

  n_cls();
  n_col(0,0,0,0);
  for(x=1;x<256;x++){
      n_col(x,
            32+32*sin(0.0+(x*3.141592653/128)),
            32+32*sin(1.0+(x*3.141592653/64)),
            32+32*sin(4.2+(x*3.141592653/128)));  
      /* n_col(x,31,x/4,x/4); */
  }
  
  fi_in=fopen(argv[1],"r");

  while(!done){
    fscanf(fi_in,"%f%f%f%f%f%f%f",&sound[sn].harm,
                                  &sound[sn].start,
                                  &sound[sn].end,
                                  &sound[sn].stamp,
                                  &sound[sn].enamp,
                                  &sound[sn].stpha,
                                  &sound[sn].enpha);
    sound[sn].length=sound[sn].end-sound[sn].start;
    sound[sn].ampmag=sound[sn].enamp-sound[sn].stamp;
    sound[sn].stpha=sound[sn].stpha*(3.141/180);
    sound[sn].enpha=sound[sn].enpha*(3.141/180);
    sound[sn].phamag=sound[sn].enpha-sound[sn].stpha;
    
    length=(sound[sn].end>length)?sound[sn].end:length;
    if(sound[sn].harm==0){done=1;sn--;}
    if(++sn>15)done=1;
  }

  fclose(fi_in);
 

  va=(unsigned char *)malloc(length);
  if(va==NULL){printf("JEFF IS BLIND!\n");exit(-69);}

  /* go through, and "do" each byte one at a time */
  
  col=0;

  mul=(float)atof(argv[3])/(float)sn;

  for (c=0;c<length;c++){
    va[c]=0;x=c%180+70;
    if(x%40==0){col++;if(col==0)col=1;}
    comp=0;
    for(s=0;s<sn;s++){  
      if((c>=sound[s].start)&&(c<sound[s].end)){
        pos=c-sound[s].start;
        fl=pos/sound[s].length;
        am=sound[s].stamp+sound[s].ampmag*fl;
        ph=sound[s].stpha+sound[s].phamag*fl;
        freq=(pos*sound[s].harm)/12;
        amval=(float)1.27*am*sin(freq+ph);
        comp=comp+amval;
      }
      va[c]=(unsigned char)((float)comp*mul);
    }
    
    yval=(unsigned char)(va[c]+(unsigned char)128);
    yval*=.78;
    asm {
    push ax
    push bx
    push cx
    push dx
    push es
    mov ax,0a000h
    mov es,ax
    
    mov bx,yval
    mov ax,320
    mul bx
    add ax,x
    mov bx,ax

    mov cx,col               
    mov es:[bx],cl

    pop es
    pop dx
    pop cx
    pop bx
    pop ax
    }
  }
               
  /* write this bitch to a file */    
  fi_out=fopen(argv[2],"w");
  
  printf("the length is %d.\n",length);
  for (c=0;c<length;c++){
    s=(int)va[c];
    fprintf(fi_out,"%c",va[c]);
   if (s<0)s=-s;    
   if (s>hi)hi=s;
  }
  fclose(fi_out);
}

void n_cls(void){
  asm {
    mov ax,0013h;
    int 10h;
  }
}

void n_col(int c,int r, int g, int b){
  
  asm {
    push ax
    push bx
    push cx
    push dx

    mov bx,c
    
    mov dx,r
    mov dh,dl

    mov cx,g
    mov ch,cl

    mov ax,b
    mov cl,al

    mov ax,1010h

    int 10h

    pop dx
    pop cx
    pop bx
    pop ax
  }
}
    
  
  
  
  

    






